/*
 * Copyright (c) 2007, Ryo Ichinose
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions are met:
 *
 *    * Redistributions of source code must retain the above copyright 
 *      notice, this list of conditions and the following disclaimer.
 *    * Redistributions in binary form must reproduce the above copyright 
 *      notice, this list of conditions and the following disclaimer in the 
 *      documentation and/or other materials provided with the distribution.
 *    * Neither the name of the auther nor the 
 *      names of its contributors may be used to endorse or promote products 
 *      derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR 
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR 
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF 
 * ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef ___ADC_H_INCLUDED_
#define ___ADC_H_INCLUDED_

#include <avr/io.h>
#include <inttypes.h>


/* A/DѴ */
#define ADC_MAX     0x3ff

/* A/DѴåѥޥ */
#define ADC_CK_2    (_BV(ADPS0))
#define ADC_CK_4    (_BV(ADPS1))
#define ADC_CK_8    (_BV(ADPS0) | _BV(ADPS1))
#define ADC_CK_16   (_BV(ADPS2))
#define ADC_CK_32   (_BV(ADPS0) | _BV(ADPS2))
#define ADC_CK_64   (_BV(ADPS1) | _BV(ADPS2))
#define ADC_CK_128  (_BV(ADPS0) | _BV(ADPS1) | _BV(ADPS2))

/* ߻/ޥ */
#define ADC_NO_INT  0
#define ADC_USE_INT 1


#define adc_set_ch(ch) { ADMUX = (ch) & (_BV(MUX2) | _BV(MUX1) | _BV(MUX0)); }
#define adc_wait()     loop_until_bit_is_set(ADCSRA, ADIF)
#define adc_get()      ADC
#define adc_start()    { ADCSRA |= _BV(ADIF); ADCSRA |= _BV(ADSC); }


void adc_set_interrupt(void (*func)(void));
void adc_init(uint8_t clock, int use_interrupt);


#endif

/* End of adc.h */
